Subject: Re: [bug#36875] [PATCH] doc: Document the use of `program-file' for mcron jobs.

From: Maxim Cournoyer <[email-masked]>
Date: Tue, 27 Aug 2019 19:59:25 +0900

Hello Ludovic,

Ludovic Courtès <[email-masked]> writes:

> Hi Maxim,
>
> Maxim Cournoyer <[email-masked]> skribis:
>
>> Ludovic Courtès <[email-masked]> writes:
>>
>>> Hello!
>>>
>>> Maxim Cournoyer <[email-masked]> skribis:
>>>
>>>> From 0fffed46b4899bf0485926399d3971a4b5e94408 Mon Sep 17 00:00:00 2001
>>>> From: Maxim Cournoyer <[email-masked]>
>>>> Date: Thu, 1 Aug 2019 07:34:17 +0900
>>>> Subject: [PATCH] doc: Document the use of `program-file' for mcron jobs.
>>>>
>>>> * doc/guix.texi (Scheduled Job Execution): Explain why using `program-file'
>>>> for an mcron job can be necessary.  Add an example.

[...]

>>> Macros are a very good example of the problem, but I wonder if it would
>>> be clearer to simply write something like:
>>>
>>>   For more complex jobs defined in Scheme where you need control over
>>>   the top level, for instance to introduce a @code{use-modules} form, you
>>>   can move your code to a separate program using the @code{program-file}
>>>   procedure of the @code{(guix gexp)} module (@pxref{G-Expressions}).
>>>   The example below illustrates that.
>>
>> I like your version, which feels to me more elegant. But, from my
>> experimentation, using (use-modules) in a nested form is fine for
>> anything else than syntax (macros).
>
> That’s right, but I strongly recommend not relying on non-toplevel
> ‘use-modules’ because (1) it’s “ugly” because it introduces new bindings
> at run time, and (2) it’s not guaranteed to work in the future—in fact,
> the just-released Guile 2.9.4 introduces “declarative modules”, which is
> probably a first step in the direction of less run-time trickery with
> modules.

Oh!  That's good to know!  Then using your proposed text as-is makes
even more sense.  Done in commit 4183105de0.

Thank you!

Maxim